/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.osgi.web.jasper.plugins.taglib;

import org.apache.jasper.compiler.tagplugin.TagPlugin;
import org.apache.jasper.compiler.tagplugin.TagPluginContext;

/**
 * @author Preston Crary
 * @see    ChooseTagPlugin
 * @see    OtherwiseTagPlugin
 */
public class WhenTagPlugin implements TagPlugin {

	@Override
	public void doTag(TagPluginContext tagPluginContext) {
		TagPluginContext parentTagPluginContext =
			tagPluginContext.getParentContext();

		if (parentTagPluginContext == null) {
			tagPluginContext.dontUseTagPlugin();

			return;
		}

		Object first = parentTagPluginContext.getPluginAttribute("first");

		if (first == null) {
			tagPluginContext.generateJavaSource("if (");

			parentTagPluginContext.setPluginAttribute("first", "false");
		}
		else {
			tagPluginContext.generateJavaSource("}\nelse if (");
		}

		tagPluginContext.generateAttribute("test");
		tagPluginContext.generateJavaSource(") {");
		tagPluginContext.generateBody();
	}

}